unit McUtils;

interface

uses Windows, SysUtils;

type
	TVersionInformation = class(TObject)
	private
	public
		Minor: Integer;
		Major: Integer;
		Build: Integer;
		procedure LoadFromFile(const FileName: TFileName);
	end;

implementation

uses BBSUtils;

{ TVersionInformation }

procedure TVersionInformation.LoadFromFile(const FileName: TFileName);
var
	Size: Integer;
	Data: DWORD;
	Buf, Value: PChar;
	VerList: array [0 .. 3] of string;
begin
	Size := GetFileVersionInfoSize(PChar(FileName), Data);
	if Size > 0 then
	begin
		Buf := AllocMem(Size);
		try
			GetFileVersionInfo(PChar(FileName), 0, Size, Buf);
			if VerQueryValue(Buf, '\StringFileInfo\041103A4\FileVersion', Pointer(Value), Data) then
			begin
				if StringSplit(Value, '.', VerList) < 4 then Abort;

				Major := StrToInt(VerList[0]);
				Minor := StrToInt(VerList[2]);
				Build := StrToInt(VerList[3]);
			end;
		finally
			FreeMem(Buf);
		end;
	end;
end;

end.

